
#define NDEBUG
#include <assert.h>  
#include <stdlib.h>

// Pklad pouit direktivy #error
#ifndef __cplusplus
#error nutno pout C++
#endif

#include <stdio.h>

//#define NELADM

#define N -100

//#line 120  "xyz.cpp" Zde je dka 120 souboru xyz.cpp

// Vlastn implementace makra assert() 

[[noreturn]]
void vpis(const char* podmnka, const char* soubor, int dka, const char* funkce)
{
	printf("Nesplnna aserce: %s, soubor %s, dka %d, funkce %s\n", podmnka, soubor, dka, funkce);
	abort();
}

// Vlastn definice makra pro aserci
#ifdef NELADM
#define ASSERT(x) (void)0
#else
#define ASSERT(x) x ? void(0) : vpis(#x, __FILE__, __LINE__, __func__)
#endif // NELADM


int faktoril(int n)
{
#undef NELADM  // Nezabere - ASSERT je ji zpracovno a bude to przdn pkaz
                // Makro NELADM je teba definovat dve, ne peklada pete definici ASSERT
	//assert(n >= 0);
	ASSERT(n >= 0);
	int vsledek = 1;
	while (n > 1) vsledek *= n--;
	return vsledek;
}

int main()
{
// direktiva #warning Ponaje C++23
#if N <= 0
//#warning neppustn hodnota N
#endif
	system("CHCP 1250 > NUL");
	int n = -5;
	printf("Faktoril %d je %d\n", n, faktoril(n));
	printf("Ferda Mravenec, prce veho druhu\n");
}

#pragma 